from machine import Pin, ADC, PWM
from time import sleep_ms as sleep
import dht

#0  LED
#1  DHT22 POWER
#12 DHT22 POWER
#13 DHT22 POWER
#14 back door
#15 dht back door
#16 dht living panel box
#17 buzzer (3.3v -> 470Ohm -> Photocell -> data/6k Omh pull down)
#18 living room buttons
#19 kitchen button
#20 dht kitchen
#28 photocell

logic_pins={
	"pullUp": [19],
	"pullDown": [14, 18]
}

for x in logic_pins:
	i=0
	for y in logic_pins[x]:
		logic_pins[x][i]=Pin(y, Pin.IN, Pin.PULL_UP if x=="pullUp" else Pin.PULL_DOWN)
		i+=1

class GPIO:
	wlan=None
	inputs={
		"back_door":Pin(14),
		"kitchen_button":Pin(19),
		"living_button":Pin(18)
	}
	class sensors:
		pins={
			"kitchen":{
				"data":Pin(20),
				"pwr":Pin(1, Pin.OUT, value=0)
			},
			"living":{
				"data":Pin(16),
				"pwr":Pin(13, Pin.OUT, value=0)
			},
			"door":{
				"data":Pin(15),
				"pwr":Pin(12, Pin.OUT, value=0)
			}
		}
		def up(name):
			if not GPIO.sensors.pins[name]["pwr"].value():
				return GPIO.sensors.pins[name]["pwr"].on()
			GPIO.sensors.pins[name]["DHT"]=dht.DHT22(GPIO.sensors.pins[name]["data"])
			return GPIO.sensors.pins[name]["DHT"]
		def down(name):
			GPIO.sensors.pins[name]["DHT"]=None
			GPIO.sensors.pins[name]["pwr"].off()
			GPIO.sensors.pins[name]["data"].init(mode=Pin.OUT, value=0)
			return None
	class light:
		value=ADC(28).read_u16
		#bulb=Pin(3, Pin.OUT, value=0)
		onboard=Pin('LED', Pin.OUT, value=0)
		offboard=Pin(0, Pin.OUT, value=0)
	class buzzer:
		pin=PWM(Pin(17))
		active=0
		lock=0
GPIO.buzzer.pin.freq(750)
GPIO.buzzer.pin.duty_u16(0)# Set the duty cycle, between 0-65535; 50% = 32767
sleep(1000)
for x in GPIO.sensors.pins:
	# power on
	GPIO.sensors.up(x)
sleep(2000)
for x in GPIO.sensors.pins:
	# configure
	GPIO.sensors.up(x)
